;     DEF FN u(a$,f$,b,d)=USR DOS
;	a$	= action: O(pen), C(lose), R(ead), W(rite), H(eader)
;		OPEN
;	f$	= file name (ends $ff)
;	b	= b : file number * 256 + access mode
;		  c : access mode: 1=read, 2=write, 3=read/write, 5=shared read
;	d	= d : create action * 256 + open action
;			  create action (file does not exist):
;			  0=error, 1=create with header, 2=create without header
;		  e : open action (file exists):
;			  0=error, 1=open + read header + pointer=0,  2=open + ignore header + pointer=0
;			  3=erase f$.BAK + rename f$.xxx to f$.BAK + follow create action
;			  4=erase f$ + follow create action
;		READ/WRITE
;	f$	= bytes: HL=address, DE=length
;	b	= b : file number * 256 + page number
;		  c : page number: 0-7
;		SET1346
;	b   = d : 1st DOS buffer * 256 (0-127) + DOS buffer # (0-127)
;		  e :
;	d	= h : 1st RAM buffer * 256 (d+e) + RAM buffer # (0-(127-e))
;		  l :


       ;org  30989      ;for DOS_Demo
       ;org  32000      ;for DOS_DeFn
EndDemo:defw DemoEnd    ;DOS end address
BytesIn:defs 2          ;start DOS_READ/WRITE address for bytes
Header: defs 2       ;DE;DOS_GET1346 DOS buffer info
Remain: defs 2       ;IX;after DOS_READ/WRITE error, bytes not read/written
                        ; -or- DOS_REFHEAD, header address in page 7
BytesAt:defs 2       ;HL;start DOS_READ/WRITE address for bytes
                        ; -or- DOS_GET1346 RAM buffer info
                        ; -or- DOS_FREESPACE free space
Zero:   defb 0
        ;set up DOS environment
DOS:    exx
        push hl         ;save H'L'
        ld   a,7
        call PageIn

;     DEF FN u(a$,f$,b,d)
;	(   a   $   0e  0   alo ahi llo lhi ,   f   $   0e  0   alo ahi llo lhi ,
; iy +  00  01  02  03  04  05  06  07  08  09  10  11  12  13  14  15  16  17
;DEFADD ^
;           b   0e  0   0   c   b   0   ,       d   0e  0   0   e   d   0   )
;           18  19  20  21  22  23  24  25      26  27  28  29  30  31  32  33

        ld   iy,(23563) ;IY=(DEFADD): address of FN u(a$,f$,b,d) parameters
        ld   hl,BASIC
        push hl         ;stack return address from DOS call
        ld   l,(iy+04)
        ld   h,(iy+05)  ;HL=a$ address
        ld   a,(hl)     ;A =action
        ld   (iy+03),a
        ld   l,(iy+13)
        ld   h,(iy+14)  ;HL=f$ address
        ld   d,(hl)     ;D =drive/user ID (FREESPACE/SETDRIVE/SETUSER)

        cp   "U"        ;action=SETUSER?
        jr   nz,SETUID
        ld   a,d
        cp   $ff
        jr   z,SETUID
        sub  65         ;change A-P to 0-15
        ld   d,a

SETUID: ld   (iy+12),d
        ld   c,(iy+22)  ;C =access mode (OPEN) -or- page (READ/WRITE)
        ld   b,(iy+23)  ;B =file number
        ld   e,(iy+30)  ;E =open action (OPEN)}-or- bytes address (READ/WRITE)
        ld   d,(iy+31)  ;D =create actn (OPEN)}
        ld   a,(iy+03)
        cp   "I"
        jp   z,$0100    ;DOS_INITIALISE
        cp   "O"
        jp   z,$0106    ;DOS_OPEN
        cp   "C"
        jp   z,$0109    ;DOS_CLOSE
        cp   "H"
        jp   z,$010f    ;DOS_REFHEAD: IX=header address in page 7

        cp   "S"
        jr   nz,CP_A
        ex   de,hl      ;HL=1st RAM buffer + RAM buffer #
        ld   d,b
        ld   e,c        ;DE=1st DOS buffer + DOS buffer #
        jp   $013f      ;DOS_SET1346

CP_A:   cp   "A"
        jp   z,$010c    ;DOS_ABANDON
        cp   "F"
        ld   a,(iy+12)  ;A =drive letter A-P
        jp   z,$0121    ;DOS_FREESPACE
        ld   a,(iy+03)
        cp   "D"
        ld   a,(iy+12)  ;A =drive letter A-P (Set) -or- $FF (Get)
        jp   z,$012d    ;DOS_SETDRIVE
        ld   a,(iy+03)
        cp   "U"
        ld   a,(iy+12)  ;A =user ID 0-15 (Set) -or- $FF (Get)
        jp   z,$0130    ;DOS_SETUSER

        ld   (BytesIn),hl    ;= f$ address
        ld   (BytesAt),de    ;= read/write address
        ld   a,(hl)     ;A =1st char of f$
        cp   "="        ;check for numeric expression marker (READ/WRITE)
        jr   nz,NOTNUM
        push de         ;evaluate bytes length expression (READ/WRITE)
        push bc
        push iy
        call PageOut    ;restore 48k ROM for calculator
        ex   de,hl
        inc  de         ;skip past "="
        ld   b,(iy+16)
        ld   c,(iy+15)
        dec  bc         ;deduct 1 from length for "="
        ld   iy,$5c3a
        call $2ab1      ;STK_ST_0
        ld   b,$1d      ;calculator code for VAL
        rst  $28
        defb $1d        ;VAL f$(2 TO)
        defb $38        ;end_calc
        call $2da2      ;FP_TO_BC = bytes length
        ld   d,b
        ld   e,c        ;DE=bytes length (READ/WRITE)
        ld   a,7
        call PageIn     ;restore +3DOS ROM
        pop  iy
        pop  bc
        pop  hl
        jr   GOTNUM

NOTNUM: ex   de,hl
        ld   e,(iy+15)
        ld   d,(iy+16)  ;DE=bytes length (READ/WRITE)
GOTNUM: ld   a,(iy+03)
        cp   "R"
        jp   z,$0112    ;DOS_READ:  if error, DE=bytes not read

        cp   "W"
        jr   nz,CPefgs
        exx
        ld   hl,(BytesIn)
        ld   de,(BytesAt)
        ld   a,(hl)
        cp   "="
        jr   z,NOCOPYW
        ld   a,(iy+22)  ;A =source page
        call PageIn
        ld   b,(iy+16)
        ld   c,(iy+15)
        ldir            ;copy bytes from f$ to source page
        ld   a,7        ;restore page 7 for DOS
        call PageIn
NOCOPYW:exx
        jp   $0115      ;DOS_WRITE: if error, DE=bytes not written

CPefgs: cp   "a"
        jp   z,$0145    ;DOS_SETACCESS
        cp   "e"
        jp   z,$0139    ;DOS_GETEOF
        cp   "f"
        ld   a,(iy+12)  ;A =drive letter A-P
        jp   z,$0142    ;DOS_FLUSH
        ld   a,(iy+03)
        cp   "g"
        jp   z,$0133    ;DOS_GETPOSITION
        cp   "s"
        ld   hl,(BytesAt)
        ld   e,c        ;EHL=file pointer
        jp   z,$0136    ;DOS_SETPOSITION

        pop  hl         ;discard redundant return address
        ld   hl,DERROK
        push hl         ;following do not return a status
        cp   "V"
        jp   z,$0103    ;DOS_VERSION
        cp   "G"
        jp   z,$013c    ;DOS_GET1346

        pop  hl         ;discard redundant return address
        ld   a,21       ;"Bad Parameter"
        and  a          ;reset Carry
        ;restore BASIC environment
BASIC:  jr   c,FINISH   ;JPs to DOS will return here
        ;A=0 + Carry=0 is an error; ie. "0 Disk not ready"
        ;so add one to error code
        inc  a
        jr   DERROR
FINISH: ld   d,a        ;D =default drive/user
        ld   a,(iy+03)  ;A =action
        cp   "R"
        jr   nz,DERROK
        exx
        ld   hl,(BytesAt)
        ld   de,(BytesIn)
        ld   a,(de)
        cp   "="
        jr   z,NOCOPYR
        ld   a,(iy+22)  ;A =destination page
        call PageIn
        ld   b,(iy+16)
        ld   c,(iy+15)
        ldir            ;copy bytes to f$ from destination page
NOCOPYR:exx
DERROK: xor  a          ;Carry set=OK, reset error code
DERROR: ld   (Header),de
        ld   (Remain),ix
        ld   (BytesAt),hl
        ex   af,af'
        ld   a,d        ;A =default drive/user
        pop  hl         ;restore H'L'
        exx
        ld   d,a        ;D =default drive/user
        call PageOut
        ex   af,af'
        ld   iy,$5C3A   ;restore ERR_NR
        ld   b,d        ;B =default drive/user
        ld   c,a        ;C =status
        ret             ;return DOS status (+1 if error)

PageIn: di
        ld   c,a
        ld   a,($5b5c)  ;BANKM (23388)
        and  %11101000
        or   c
        ld   ($5b5c),a
        ld   bc,$7ffd   ;32765
        out  (c),a
        ei
        reti

PageOut:di
        ld   a,($5b5c)  ;BANKM (23388)
        set  4,a
        and  %11111000
        ld   ($5b5c),a
        ld   bc,$7ffd   ;32765
        out  (c),a
        ei
        reti

DemoEnd: